;nyquist plug-in
;version 1
;type process
;name "Karaoke Effekt..."
;action "Karaoke..."
;info " ...nach einem Original von David R. Sky\n EQ 0: Kanal invertieren - EQ 1: Frequenzband bearbeiten
;control bc "EQ:" int "" 1 0 1
;control above "Bass" int "Hz" 100 100 700
;control bass "Pegel" int "%" 50 0 100
;control below "Hhen" int "Hz" 16000 1400 16000
;control treble "Pegel" int "%" 50 0 100

; Center pan Remover by David R. Sky November 12, 2004
; Released under terms of the GNU Public License
; http://www.opensource.org/licenses/gpl-license.php
; Select either band of frequencies to remove
; (define frequency range),
; or invert one channel
; result is still stereo but sounds mono
; (both channels have been panned to center)

(defun butterfly (sound) 
(vector 
(sum (mult (aref sound 0) 0.5)
(mult (aref sound 1) -0.5))
(sum (mult (aref sound 0) 0.5)
(mult (aref sound 1) -0.5))))

(defun eqband (sound)
(vector
(sum (mult (/ treble 200.0) (highpass8 (aref sound 0) below)) (mult (/ bass 200.0) (lowpass8 (aref sound 0) above)))
(sum (mult (/ treble 200.0) (highpass8 (aref sound 1) below)) (mult (/ bass 200.0) (lowpass8 (aref sound 1) above)))))

(defun inveqband (sound)
(vector
(highpass8 (lowpass8 (aref sound 0) below) above)
(highpass8 (lowpass8 (aref sound 1) below) above)))

(butterfly s)

;(if (= bc 1) ; invert one channel
;(vector 

(scale 0.5 s)

(cond

((= bc 0)    ; invert band of frequencies
(butterfly s))

((= bc 1)   ; invert one channel
(sum (inveqband (butterfly s)) (eqband s))))

